/* ------------------------------------------------------------------------ */
static void  ReadFormattedNumbers( FILE *Fptr, double *next, ... )
{
   va_list args;                       /* Variable argument list  */
   for( va_start(args,next);  next;  next = va_arg(args,double *) )  ReadFormattedString(Fptr,next);
   va_end( args );                     /* Help function make normal return  */
   ReadFormattedString(Fptr,NULL);     /* Always get a newline at the end   */
}


/* ------------------------------------------------------------------------ */
static void  ReadFormattedString( FILE *Fptr, double *numberToReturnToCallingFunction )
{
   char line[256];   static long lineNumber = 0;   lineNumber++;
   if( !fgets(line,256,Fptr) ) { printf("\n Error: End of file found while trying to read line %ld of input file.\n", lineNumber);  exit(4); }
   if( numberToReturnToCallingFunction && (strlen(line) < 60 || (*numberToReturnToCallingFunction=StringToDouble(line+59))==HUGE_VAL) ) 
      { printf("\n Error: Expecting number starting at 60th character of line %ld in input file:\n\n%s\n", lineNumber, line );  exit(5); }
}

